// $Id: BasicApplication.h,v 1.7 2002/08/24 19:08:19 hns Exp $
//
//  Application.h
//  CocoaBasic
//
//  Created by Dr. H. Nikolaus Schaller on Sat Jun 15 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
// #import "BasicDocument.h"
// #import "HNSSortedTableView.h"

// keys into user defaults
#define Preferences_confirmSettings	@"confirmSettingsOnBuild"
#define Preferences_keepBackup		@"keepBackup"
#define Preferences_autoSave		@"autoSave"
#define Preferences_saveBeforeRun	@"saveBeforeRun"
#define Preferences_showDebugRun	@"showDebugOnRun"
#define Preferences_compileApplic	@"compileToApplicationsFolder"
#define Preferences_showApplic		@"showApplicationInFinder"
#define Preferences_devLang			@"developmentLanguage"
#define getPreference(Name, Type)	[[NSUserDefaults standardUserDefaults] Type##ForKey:Name]

@interface BasicApplication : NSApplication {
	IBOutlet NSWindow *find;
	IBOutlet NSWindow *preferences;
	IBOutlet NSButtonCell *confirmSettings;
	IBOutlet NSButtonCell *keepBackup;
	IBOutlet NSButtonCell *autoSave;
	IBOutlet NSButtonCell *saveBeforeRun;
	IBOutlet NSButtonCell *showDebugRun;
	IBOutlet NSButtonCell *compileApplic;
	IBOutlet NSButtonCell *showApplic;
	IBOutlet NSPopUpButton *developmentLanguage;
}

+ (NSDictionary *) keyword:(NSString *) res;	// get entry from keyword ressource

- (NSDictionary *) factorySettings;

// menu actions
- (IBAction) orderFrontStandardAboutPanel:(id)Sender;
- (IBAction) orderFrontPreferencesPanel:(id)Sender;
- (IBAction) savePreferences:(id)Sender;
- (IBAction) factorySettings:(id)Sender;

@end
